<?php
/**
 * The base template for displaying 404 pages (not found).
 *
 * @package Grimm
 */

$page_404_image     = get_theme_mod( 'page_404_image', grimm_theme()->customizer->get_default( 'page_404_image' ) );
$btn_style_preset   = get_theme_mod( 'page_404_btn_style_preset', grimm_theme()->customizer->get_default( 'page_404_btn_style_preset' ) );
$text_color         = get_theme_mod( 'page_404_text_color', grimm_theme()->customizer->get_default( 'page_404_text_color' ) );
$additional_class   = ( 'light' === $text_color ) ? 'invert' : 'regular';
$page_404_image_url = '';

if ( $page_404_image ) {
	$page_404_image_url = esc_url( grimm_render_theme_url( $page_404_image ) );
}
?>
<?php get_header( grimm_template_base() ); ?>

	<?php grimm_site_breadcrumbs(); ?>
	<div style="background: url(<?php echo $page_404_image_url; ?>) center no-repeat ; -webkit-background-size: cover;
	background-size: cover; padding: 75px 0; margin-top: 75px;">
		<div <?php grimm_content_wrap_class(); ?>>

			<div class="row">

				<div id="primary" <?php grimm_primary_content_class(); ?>>

					<main id="main" class="site-main" role="main">

						<?php include grimm_template_path(); ?>

					</main><!-- #main -->

				</div><!-- #primary -->

				<?php get_sidebar(); // Loads the sidebar.php. ?>

			</div><!-- .row -->

		</div><!-- .site-content_wrap -->
	</div>
<?php get_footer( grimm_template_base() ); ?>
